//! @title  Ring oscillator temperature sensor - top file
//! @file   top.v
//! @author Ramiro Javier Rossi - UTN Researcher
//! @date   29-10-2021

//! - Top
//! - **i_enable** is the block enable input.
//! - **clock** is the block enable input.
//! - **o_ring_osc** is the output of the ring oscillator with the frequency generated by itself. Connect it to the input of the freq_divider
//! - **o_freq_divider** is the block output to the specified pin in the board. It has the value of the ring oscillator frequency divided by the DIVIDER parameter
//! - **o_led__module_enable** is the block output to the led. Turn on each time you press the enable button.

`include "ring_osc.v"
`include "counter.v"
`include "frequency_divider.v"
`include "blinky.v"

module top
    (
        input  i_enable, //! enable signal
        input  clock, //! Clock signal
        output o_led__module_enable, //! LED indicating module is ON
        output o_ring_osc,         //! ring oscillator output. Connect it to the frequency input of the fre_divider
        output o_freq_divider   //! Freq divider output
    );

    parameter DIV = 12; //! Divider of the ring-oscillator output frequency
    parameter NUM_INVERTER = 12; //! Number of inverters inside the ring-oscillator

    ring_osc#(
            .NUMBER_INVERTERS(NUM_INVERTER) //! Number of inverters inside the ring-oscillator
        )
         u_ring_osc
           (
                 .i_enable(i_enable),
                 .o_ring(o_ring_osc)
             );

    freq_divider#(
            .DIVIDER(DIV) //! Divider of the ring-oscillator output frequency
        )
        u_freq_divider
            (
                .i_enable(i_enable),
                .i_frequency(o_ring_osc),
                .o_divided_requency(o_freq_divider)
            );

    blinky#()
        u_blinky
            (
                .i_enable(i_enable),
                .clock(clock),
                .o_to_led(o_led__module_enable)
            );

endmodule //top
